#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2600seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 2600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2600seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven26004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven26004xi = {
                1:'-1001x-2249y835z',
                2:'-1001x-939y2324z',
                3:'-1018x-771y2264z',
                4:'-1038x-704y2277z',
                5:'-1054x-637y2289z',
                6:'-1065x-570y2301z',
                7:'-106x-1329y2232z',
                8:'-1073x-503y2313z',
                9:'-1076x-438y2325z',
                10:'-108x-2324y1159z',
                11:'-1095x-1923y1364z',
                12:'-1113x-2186y860z',
                13:'-1187x-1851y1386z',
                14:'-1222x-2117y884z',
                15:'-1274x-1775y1408z',
                16:'-131x-2511y661z',
                17:'-1326x-2042y909z',
                18:'-1329x-2234y6z',
                19:'-1356x-1695y1429z',
                20:'-1426x-1963y933z',
                21:'-1433x-1611y1451z',
                22:'-1444x-2161y32z',
                23:'-1506x-1523y1473z',
                24:'-1521x-1878y957z',
                25:'-1554x-2082y58z',
                26:'-1572x-1432y1494z',
                27:'-1610x-1789y981z',
                28:'-1633x-1339y1515z',
                29:'-1661x-1998y84z',
                30:'-1689x-1242y1536z',
                31:'-1695x-1695y1005z',
                32:'-172x-1299y2245z',
                33:'-1739x-1144y1557z',
                34:'-1763x-1907y110z',
                35:'-1774x-1597y1029z',
                36:'-1783x-1043y1578z',
                37:'-1821x-941y1598z',
                38:'-1847x-1495y1053z',
                39:'-1853x-838y1619z',
                40:'-1859x-1812y136z',
                41:'-1879x-734y1639z',
                42:'-1899x-629y1659z',
                43:'-1913x-524y1679z',
                44:'-1914x-1390y1077z',
                45:'-1922x-420y1699z',
                46:'-1950x-1711y161z',
                47:'-1975x-1282y1100z',
                48:'-2030x-1172y1124z',
                49:'-2036x-1605y187z',
                50:'-2078x-1059y1147z',
                51:'-2115x-1495y213z',
                52:'-2120x-944y1171z',
                53:'-2156x-827y1194z',
                54:'-2185x-709y1217z',
                55:'-2189x-1381y239z',
                56:'-2207x-591y1240z',
                57:'-2223x-472y1262z',
                58:'-2232x-353y1285z',
                59:'-2234x-234y1308z',
                60:'-2256x-1264y265z',
                61:'-228x-2303y1182z',
                62:'-2317x-1143y291z',
                63:'-236x-1266y2258z',
                64:'-2370x-1019y317z',
                65:'-23x-25y2599z',
                66:'-2417x-892y343z',
                67:'-2457x-763y368z',
                68:'-2490x-632y394z',
                69:'-25x-371y2573z',
                70:'-262x-2494y686z',
                71:'-296x-1230y2271z',
                72:'-347x-2277y1206z',
                73:'-354x-1191y2283z',
                74:'-37x-1355y2218z',
                75:'-391x-2469y711z',
                76:'-39x-47y2599z',
                77:'-408x-1149y2295z',
                78:'-41x-343y2576z',
                79:'-459x-1105y2308z',
                80:'-463x-2243y1229z',
                81:'-506x-1058y2319z',
                82:'-518x-2439y736z',
                83:'-52x-69y2598z',
                84:'-54x-315y2580z',
                85:'-550x-1010y2331z',
                86:'-576x-2204y1251z',
                87:'-590x-960y2342z',
                88:'-5x-397y2569z',
                89:'-626x-908y2354z',
                90:'-63x-94y2597z',
                91:'-643x-2401y761z',
                92:'-658x-856y2364z',
                93:'-65x-287y2583z',
                94:'-687x-2159y1274z',
                95:'-687x-802y2375z',
                96:'-6x-6y2599z',
                97:'-711x-748y2386z',
                98:'-71x-119y2596z',
                99:'-727x-133y2492z',
                100:'-732x-693y2396z',
                101:'-73x-258y2586z',
                102:'-743x-177y2485z',
                103:'-749x-638y2406z',
                104:'-757x-223y2477z',
                105:'-762x-583y2416z',
                106:'-765x-2356y786z',
                107:'-767x-270y2469z',
                108:'-772x-529y2425z',
                109:'-775x-320y2461z',
                110:'-778x-475y2434z',
                111:'-779x-370y2452z',
                112:'-77x-146y2594z',
                113:'-780x-422y2443z',
                114:'-78x-229y2588z',
                115:'-795x-2108y1297z',
                116:'-80x-173y2592z',
                117:'-80x-201y2590z',
                118:'-885x-2306y810z',
                119:'-899x-2051y1319z',
                120:'-993x-838y2251z',
                121:'-999x-1990y1341z',
                122:'0x-2520y636z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2600seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2600seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2600SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2600SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2600SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2600SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2600SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven26004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2600SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2600SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2600SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven26004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven26004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2600SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2600SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2600SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2600seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       